package com.steerinfo.ems.tcm0323.controller;

import com.steerinfo.ems.tcm0323.model.TCm0323;
import com.steerinfo.ems.tcm0323.service.ITCm0323Service;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.HashMap;
import java.util.List;

/**
 * TCm0323 RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2019-10-28 09:32
 * 类描述
 * 修订历史：
 * 日期：2019-10-28
 * 作者：generator
 * 参考：
 * 描述：TCm0323 RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/tcm0323s")
public class TCm0323Controller extends BaseRESTfulController {

    private static final Logger LOGGER = LoggerFactory.getLogger(TCm0323Controller.class);

    @Autowired
    ITCm0323Service tCm0323Service;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("tcm0323:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<TCm0323> list = tCm0323Service.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("tcm0323:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<TCm0323> list = tCm0323Service.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据TCm0323对象创建")
    @ApiImplicitParam(name = "tCm0323", value = "详细实体tCm0323", required = true, dataType = "TCm0323")
    //@RequiresPermissions("tcm0323:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute TCm0323 model){
        TCm0323 tCm0323 = tCm0323Service.add(model);
        return success(tCm0323);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("tcm0323:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        TCm0323 tCm0323 = tCm0323Service.getById(id);
        return success(tCm0323);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的tCm0323信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "tCm0323", value = "详细实体tCm0323", required = true, dataType = "TCm0323")
    })
    //@RequiresPermissions("tcm0323:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody TCm0323 model){
        LOGGER.info("动力检测项目维护表更新前数据是" + tCm0323Service.getById(model.getItemcode()).toString());
        model.setId(id);
        TCm0323 tCm0323 = tCm0323Service.modify(model);
        LOGGER.info("动力检测项目维护表更新后数据是" + tCm0323.toString());
        return success(tCm0323);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("tcm0323:delete")
    @DeleteMapping(value = "/{id}")
    public RESTfulResult delete(@PathVariable String id){
        String[] array = id.split(",");
        if(array.length == 1){
            LOGGER.info("动力检测项目要删除的数据是" + tCm0323Service.getById(id).toString());
            tCm0323Service.delete(id);
            return success();
        }
        else if(array.length > 1) {
            for (int i = 0; i < array.length; i++) {
                LOGGER.info("动力检测项目要删除的第" + (i + 1) + "条数据是" + tCm0323Service.getById(array[i]).toString());
                tCm0323Service.delete(array[i]);
            }
            LOGGER.info("动力检测项目要删除数据共" + array.length + "条。");
            return success();
        }
        else {
            return failed(null, "请输入要删除的id");
        }
    }

    @ApiOperation(value="未选定的监测项目多选框", notes="(查询Unsitem的id和name")
    @GetMapping(value = "/getunsitemidandname/")
    public RESTfulResult getUnsitemNameAndId(){
        List<TCm0323> tCm0323 = tCm0323Service.getUnsitemNameAndId();
        return success(tCm0323);
    }

    @ApiOperation(value="监测项目下拉框", notes="查询id和name")
    @GetMapping(value = "/getidandname/")
    public RESTfulResult getNameAndId(){
        List<TCm0323> tCm0323 = tCm0323Service.getNameAndId();
        return success(tCm0323);
    }
}
